> ## Documentation Index
> Fetch the complete documentation index at: https://www.canva.dev/docs/apps/llms.txt
> Use this file to discover all available pages before exploring further.
# Create URL import job
Create an asynchronous job to import a design created in another application, using a URL.
Starts a new [asynchronous job](https://www.canva.dev/docs/apps/rest-apis/requests-responses/#asynchronous-job-endpoints) to import an external file from a URL as a new design in Canva.
Supported file types for imports are listed in [Design imports overview](https://www.canva.dev/docs/apps/rest-apis/reference/design-imports/#supported-file-types).
For more information on the workflow for using asynchronous jobs, see [API requests and responses](https://www.canva.dev/docs/apps/rest-apis/requests-responses/#asynchronous-job-endpoints). You can check the status and get the results of design import jobs created with this API using the [Get URL import job API](https://www.canva.dev/docs/apps/rest-apis/reference/design-imports/get-url-import-job/).
## HTTP method and URL path
POST https\://api.canva.com/rest/v1/url-imports
This operation is rate limited to 20 requests per minute for each user of your app.
## Authentication and authorization
This endpoint requires a valid access token that acts on behalf of a user. For more information, see [Generate an access token](/docs/apps/rest-apis/reference/authentication/generate-access-token).
### Scopes
The access token must have all the following [scopes](/docs/apps/rest-apis/scopes) (permissions):
* `design:content:write`
## Header parameters
Provides credentials to authenticate the request, in the form of a `Bearer` token.
For example: `Authorization: Bearer {token}`
Indicates the media type of the information sent in the request. This must be set to `application/json`.
For example: `Content-Type: application/json`
## Body parameters
A title for the design.
**Minimum length:** `1`
**Maximum length:** `255`
The URL of the file to import. This URL must be accessible from the internet and be publicly available.
**Minimum length:** `1`
**Maximum length:** `2048`
The MIME type of the file being imported. If not provided, Canva attempts to automatically detect the type of the file.
**Minimum length:** `1`
**Maximum length:** `100`
## Example request
Examples for using the `/v1/url-imports` endpoint:
```sh
curl --request POST 'https://api.canva.com/rest/v1/url-imports' \
--header 'Authorization: Bearer {token}' \
--header 'Content-Type: application/json' \
--data '{
"title": "My Awesome Design",
"url": "string",
"mime_type": "application/vnd.apple.keynote"
}'
```
```js
const fetch = require("node-fetch");
fetch("https://api.canva.com/rest/v1/url-imports", {
method: "POST",
headers: {
"Authorization": "Bearer {token}",
"Content-Type": "application/json",
},
body: JSON.stringify({
"title": "My Awesome Design",
"url": "string",
"mime_type": "application/vnd.apple.keynote"
}),
})
.then(async (response) => {
const data = await response.json();
console.log(data);
})
.catch(err => console.error(err));
```
```java
import java.io.IOException;
import java.net.URI;
import java.net.http.*;
public class ApiExample {
public static void main(String[] args) throws IOException, InterruptedException {
HttpRequest request = HttpRequest.newBuilder()
.uri(URI.create("https://api.canva.com/rest/v1/url-imports"))
.header("Authorization", "Bearer {token}")
.header("Content-Type", "application/json")
.method("POST", HttpRequest.BodyPublishers.ofString("{\"title\": \"My Awesome Design\", \"url\": \"string\", \"mime_type\": \"application/vnd.apple.keynote\"}"))
.build();
HttpResponse response = HttpClient.newHttpClient().send(
request,
HttpResponse.BodyHandlers.ofString()
);
System.out.println(response.body());
}
}
```
```py
import requests
headers = {
"Authorization": "Bearer {token}",
"Content-Type": "application/json"
}
data = {
"title": "My Awesome Design",
"url": "string",
"mime_type": "application/vnd.apple.keynote"
}
response = requests.post("https://api.canva.com/rest/v1/url-imports",
headers=headers,
json=data
)
print(response.json())
```
```csharp
using System.Net.Http;
var client = new HttpClient();
var request = new HttpRequestMessage
{
Method = HttpMethod.Post,
RequestUri = new Uri("https://api.canva.com/rest/v1/url-imports"),
Headers =
{
{ "Authorization", "Bearer {token}" },
},
Content = new StringContent(
"{\"title\": \"My Awesome Design\", \"url\": \"string\", \"mime_type\": \"application/vnd.apple.keynote\"}",
Encoding.UTF8,
"application/json"
),
};
using (var response = await client.SendAsync(request))
{
response.EnsureSuccessStatusCode();
var body = await response.Content.ReadAsStringAsync();
Console.WriteLine(body);
};
```
```go
package main
import (
"fmt"
"io"
"net/http"
"strings"
)
func main() {
payload := strings.NewReader(`{
"title": "My Awesome Design",
"url": "string",
"mime_type": "application/vnd.apple.keynote"
}`)
url := "https://api.canva.com/rest/v1/url-imports"
req, _ := http.NewRequest("POST", url, payload)
req.Header.Add("Authorization", "Bearer {token}")
req.Header.Add("Content-Type", "application/json")
res, _ := http.DefaultClient.Do(req)
defer res.Body.Close()
body, _ := io.ReadAll(res.Body)
fmt.Println(string(body))
}
```
```php
$curl = curl_init();
curl_setopt_array($curl, array(
CURLOPT_URL => "https://api.canva.com/rest/v1/url-imports",
CURLOPT_CUSTOMREQUEST => "POST",
CURLOPT_RETURNTRANSFER => true,
CURLOPT_HTTPHEADER => array(
'Authorization: Bearer {token}',
'Content-Type: application/json',
),
CURLOPT_POSTFIELDS => json_encode([
"title" => "My Awesome Design",
"url" => "string",
"mime_type" => "application/vnd.apple.keynote"
])
));
$response = curl_exec($curl);
$err = curl_error($curl);
curl_close($curl);
if (empty($err)) {
echo $response;
} else {
echo "Error: " . $err;
}
```
```ruby
require 'net/http'
require 'uri'
url = URI('https://api.canva.com/rest/v1/url-imports')
http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true
request = Net::HTTP::Post.new(url)
request['Authorization'] = 'Bearer {token}'
request['Content-Type'] = 'application/json'
request.body = <
## Success response
If successful, the endpoint returns a `200` response with a JSON body with the following parameters:
The status of the design import job.
Properties of job>} defaultExpanded={true}>
The ID of the design import job.
The status of the design import job.
**Available values:**
* `failed`
* `in_progress`
* `success`
Properties of result>}>
A list of designs imported from the external file. It usually contains one item.
Imports with a large number of pages or assets are split into multiple designs.
Properties of designs>}>
The design ID.
A temporary set of URLs for viewing or editing the design.
Properties of urls>}>
A temporary editing URL for the design. This URL is only accessible to the user that made the API request, and is designed to support [return navigation](https://www.canva.dev/docs/apps/rest-apis/return-navigation-guide/) workflows.
NOTE: This is not a permanent URL, it is only valid for 30 days.
A temporary viewing URL for the design. This URL is only accessible to the user that made the API request, and is designed to support [return navigation](https://www.canva.dev/docs/apps/rest-apis/return-navigation-guide/) workflows.
NOTE: This is not a permanent URL, it is only valid for 30 days.
When the design was created in Canva, as a Unix timestamp (in seconds since the Unix
Epoch).
When the design was last updated in Canva, as a Unix timestamp (in seconds since the
Unix Epoch).
The design title.
URL of the design.
A thumbnail image representing the object.
Properties of thumbnail>}>
The width of the thumbnail image in pixels.
The height of the thumbnail image in pixels.
A URL for retrieving the thumbnail image.
This URL expires after 15 minutes. This URL includes a query string
that's required for retrieving the thumbnail.
The total number of pages in the design. Some design types don't have pages (for example, Canva docs).
If the import job fails, this object provides details about the error.
Properties of error>}>
A short string about why the import failed. This field can be used to handle errors
programmatically.
**Available values:**
* `design_creation_throttled`
* `design_import_throttled`
* `duplicate_import`
* `internal_error`
* `invalid_file`
* `fetch_failed`
A human-readable description of what went wrong.
## Example responses
### In progress job
```json
{
"job": {
"id": "e08861ae-3b29-45db-8dc1-1fe0bf7f1cc8",
"status": "in_progress"
}
}
```
### Successfully completed job
```json
{
"job": {
"id": "e08861ae-3b29-45db-8dc1-1fe0bf7f1cc8",
"status": "success",
"result": {
"designs": [
{
"id": "DAGQm2AkzOk",
"title": "My Awesome Design",
"thumbnail": {
"width": 376,
"height": 531,
"url": "https://document-export.canva.com/..."
},
"urls": {
"edit_url": "https://www.canva.com/api/design/...",
"view_url": "https://www.canva.com/api/design/..."
},
"created_at": 1726198998,
"updated_at": 1726199000
}
]
}
}
}
```
### Failed job
```json
{
"job": {
"id": "e08861ae-3b29-45db-8dc1-1fe0bf7f1cc8",
"status": "failed",
"error": {
"code": "invalid_file",
"message": "Document could not be imported because the file is corrupt."
}
}
}
```
## Error responses
### 400 Bad Request
A short string indicating what failed. This field can be used to handle errors programmatically. For a complete list of error codes, see [Error responses](/docs/apps/rest-apis/error-responses/).
A human-readable description of what went wrong.
#### Example error response
##### A design import for the URL is already in progress
```json
{
"code": "invalid_request",
"message": "Design import for url {url} already in progress"
}
```
### 404 Not Found
A short string indicating what failed. This field can be used to handle errors programmatically. For a complete list of error codes, see [Error responses](/docs/apps/rest-apis/error-responses/).
A human-readable description of what went wrong.
#### Example error response
##### Job with ID not found
```json
{
"code": "not_found",
"message": "Job with Id {jobId} not found"
}
```